'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _ListHandler = require('./ListHandler');

var _ListHandler2 = _interopRequireDefault(_ListHandler);

var _ItemHandler = require('./ItemHandler');

var _ItemHandler2 = _interopRequireDefault(_ItemHandler);

var _middleware2 = require('./middleware');

var _types = require('./types');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Endpoint = function (_Component) {
  _inherits(Endpoint, _Component);

  function Endpoint() {
    var _temp, _this, _ret;

    _classCallCheck(this, Endpoint);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = { response: false }, _this.handlers = false, _this.getChildContext = function () {
      var _this$props = _this.props,
          propsPath = _this$props.path,
          persist = _this$props.persist;
      var _this$context$rest = _this.context.rest,
          base = _this$context$rest.base,
          contextPath = _this$context$rest.path,
          middleware = _this$context$rest.middleware;


      var path = persist ? propsPath[0] === '/' ? [propsPath] : [].concat(contextPath, [propsPath]) : contextPath;

      return {
        rest: _extends({}, _this.context.rest, {
          base: base,
          path: path,
          middleware: middleware
        })
      };
    }, _this.componentWillMount = function () {
      _this.createHandlers(_this.props, _this.context);
      if (!_this.props.noFetchOnMount) {
        _this.handlers.fetch(_this.props.options);
      }
    }, _this.componentWillReceiveProps = function (nextProps, nextContext) {
      _this.createHandlers(nextProps, nextContext);
      if (!nextProps.noFetchOnMount) {
        _this.handlers.fetch(nextProps.options);
      }
    }, _this.createHandlers = function (props, context) {
      var pk = props.pk,
          propsPath = props.path,
          options = props.options,
          propsMiddleware = props.middleware,
          suppressUpdate = props.suppressUpdate;
      var _context$rest = context.rest,
          base = _context$rest.base,
          contextPath = _context$rest.path,
          contextMiddleware = _context$rest.middleware;


      var path = propsPath[0] === '/' ? propsPath.slice(1) : [].concat(contextPath, [propsPath]).join('/');
      var url = base + '/' + path;

      if (!pk) {
        var update = (0, _middleware2.createMiddleware)(function (request) {
          return request;
        }, function (p) {
          return p.then(function (response) {
            if (response.request.type !== _types.METHOD.BROWSE) {
              _this.handlers.browse(options);
            } else {
              if (!suppressUpdate) {
                _this.setState({ response: response });
              }
            }
            return response;
          });
        });

        var middleware = [].concat(contextMiddleware, propsMiddleware, [update]);
        var altfetch = (0, _middleware2.fetchWithMiddleware)(middleware);
        _this.handlers = new _ListHandler2.default(url, altfetch);
      } else {
        var _update = (0, _middleware2.createMiddleware)(function (request) {
          return request;
        }, function (p) {
          return p.then(function (response) {
            if (response.request.type === _types.METHOD.DESTROY) {
              _this.handlers.read();
            } else {
              if (!suppressUpdate) {
                _this.setState({ response: response });
              }
            }
            return response;
          });
        });

        var _middleware = [].concat(contextMiddleware, propsMiddleware, [_update]);
        var _altfetch = (0, _middleware2.fetchWithMiddleware)(_middleware);
        _this.handlers = new _ItemHandler2.default(url, pk, _altfetch);
      }
    }, _this.render = function () {
      var _this$props2 = _this.props,
          component = _this$props2.component,
          render = _this$props2.render,
          children = _this$props2.children;
      var response = _this.state.response;

      var handlers = _this.handlers;

      var props = {
        response: response,
        handlers: handlers
      };

      return component ? _react2.default.createElement(component, props) : render ? render(props) : children ? typeof children === 'function' ? children(props) : !Array.isArray(children) || children.length ? _react2.default.cloneElement(_react2.default.Children.only(children), props) : null : null;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  return Endpoint;
}(_react.Component);

Endpoint.propTypes = {
  component: _propTypes2.default.func,
  render: _propTypes2.default.func,
  children: _propTypes2.default.oneOfType([_propTypes2.default.func, _propTypes2.default.node]),

  path: _propTypes2.default.string.isRequired,
  pk: _propTypes2.default.string,
  middleware: _propTypes2.default.array,

  options: _propTypes2.default.object,

  noFetchOnMount: _propTypes2.default.bool,
  suppressUpdate: _propTypes2.default.bool,

  persist: _propTypes2.default.bool
};
Endpoint.defaultProps = {
  middleware: [],

  options: {},

  noFetchOnMount: false,
  suppressUpdate: false,

  persist: true
};
Endpoint.contextTypes = {
  rest: _propTypes2.default.shape({
    base: _propTypes2.default.string.isRequired,
    path: _propTypes2.default.array.isRequired,
    middleware: _propTypes2.default.array.isRequired
  })
};
Endpoint.childContextTypes = {
  rest: _propTypes2.default.object.isRequired
};
exports.default = Endpoint;